VERSION 5.00
Begin VB.Form frmRegion 
   Caption         =   "Regions Example"
   ClientHeight    =   3735
   ClientLeft      =   1185
   ClientTop       =   1575
   ClientWidth     =   6840
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   249
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   456
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   555
      Left            =   5580
      TabIndex        =   8
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton cmdCombine 
      Caption         =   "Combine && &Fill Selected"
      Height          =   555
      Index           =   0
      Left            =   2040
      TabIndex        =   7
      Top             =   3120
      Width           =   1815
   End
   Begin VB.CommandButton cmdCombine 
      Caption         =   "&Combine && Clip Selected"
      Default         =   -1  'True
      Height          =   555
      Index           =   1
      Left            =   60
      TabIndex        =   6
      Top             =   3120
      Width           =   1875
   End
   Begin VB.PictureBox picOut 
      DrawWidth       =   2
      FillColor       =   &H0000FFFF&
      FillStyle       =   0  'Solid
      ForeColor       =   &H00FF00FF&
      Height          =   3015
      Left            =   60
      ScaleHeight     =   199
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   444
      TabIndex        =   0
      Top             =   0
      Width           =   6690
      Begin VB.Label Label1 
         Caption         =   "PolyPolygonal Region:"
         Height          =   195
         Left            =   180
         TabIndex        =   5
         Top             =   1320
         Width           =   1695
      End
      Begin VB.Label lblRoundRect 
         Caption         =   "Round Rectangular:"
         Height          =   195
         Left            =   4500
         TabIndex        =   4
         Top             =   60
         Width           =   1515
      End
      Begin VB.Label lblPolygon 
         Caption         =   "Polygon:"
         Height          =   195
         Left            =   3120
         TabIndex        =   3
         Top             =   60
         Width           =   1275
      End
      Begin VB.Label lblElliptic 
         Caption         =   "Elliptic:"
         Height          =   195
         Left            =   1680
         TabIndex        =   2
         Top             =   60
         Width           =   855
      End
      Begin VB.Label lblRect 
         Caption         =   "Rectangular:"
         Height          =   195
         Left            =   180
         TabIndex        =   1
         Top             =   60
         Width           =   1035
      End
   End
End
Attribute VB_Name = "frmRegion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' region sample program
' Copyright (c) 1995-1997 by Desaware Inc.


Option Explicit
Dim hCombined&  ' Combined region
Dim rSelected%(4) ' Array indicating selection state
#If Win32 Then
Dim hRegions(4) As Long ' Array of regions
#Else
Dim hRegions(4) As Integer
#End If
Public dl

'
' Combine selected regions into one region
' Index 0 means combine and fill the selected regions
' Index 1 means clip to the combined region
Private Sub cmdCombine_Click(Index As Integer)
    Dim i%, fAnySelected As Integer, WhichSelected%
    WhichSelected% = -1
    
    ' Count the number selected, and determine which is first
    For i% = 0 To 4
        If rSelected%(i%) = True Then
            fAnySelected = fAnySelected + 1
            If WhichSelected% = -1 Then WhichSelected% = i%
        End If
    Next i%
    Select Case fAnySelected
        Case 0:
            MsgBox "No regions are selected!", vbCritical, "Error:"
        Case 1:
            Load frmCombine
            ' Debug.Print hRegions(WhichSelected%)
            frmCombine.Initialize Index, hRegions(WhichSelected%)
        Case Else:
            If hCombined <> 0 Then
                dl = DeleteObject(hCombined)
            End If
            hCombined = CreateRectRgn(0, 0, 0, 0)
            ' This is one way to copy a region
            dl = CombineRgn(hCombined, hRegions(WhichSelected%), hCombined, RGN_DIFF)
            ' Combine in the rest of the regions
            For i% = WhichSelected% + 1 To 4
                If rSelected%(i%) = True Then
                    dl = CombineRgn(hCombined, hCombined, hRegions(i%), RGN_OR)
                End If
            Next i%
            Load frmCombine
            frmCombine.Initialize Index, hCombined
    End Select
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub



'
' Initialize a bunch of regions
'
Private Sub Form_Load()
    Dim myPolygon(5) As POINTAPI
    Dim myPolyPolygon() As POINTAPI
    #If Win32 Then
        Dim myPolyCount() As Long
        Dim hPPRegion As Long, hTRegion As Long
    #Else
        Dim myPolyCount() As Integer
        Dim hPPRegion As Integer, hTRegion As Integer
    #End If
    Dim PPCount%
    Dim i%, j%
    
    'Polygon region  - This draws a star
    myPolygon(0).X = 233:  myPolygon(0).Y = 19
    myPolygon(1).X = 212:  myPolygon(1).Y = 57
    myPolygon(2).X = 257:    myPolygon(2).Y = 31
    myPolygon(3).X = 209:    myPolygon(3).Y = 31
    myPolygon(4).X = 244:    myPolygon(4).Y = 57
    myPolygon(5).X = 233:    myPolygon(5).Y = 19
    hRegions(rPOLYGON) = CreatePolygonRgn(myPolygon(0), 6, WINDING)

    'Poly-Polygon region
    
    PPCount% = 10
    ReDim myPolyPolygon(PPCount% * 6 - 1)
    ReDim myPolyCount(PPCount% - 1)
    
    ' Copy the star 10 times
    For i% = 0 To 5
        For j% = 0 To PPCount% - 1
            myPolyPolygon(i% + j% * 6).X = myPolygon(i%).X - 200 + 40 * j%
            myPolyPolygon(i% + j% * 6).Y = myPolygon(i%).Y + 100
        Next j%
'        myPolyPolygon(i% + 5).X = myPolygon(i%).X - 200
'        myPolyPolygon(i% + 5).Y = myPolygon(i%).Y + 100
    Next i%
    
    For i% = 0 To PPCount% - 1
        myPolyCount(i%) = 6
    Next i%

    hRegions(rPOLYPOLYGON) = CreatePolyPolygonRgn(myPolyPolygon(0), myPolyCount(0), PPCount%, WINDING)
    
    'Rectangle
    hRegions(rRECT) = CreateRectRgn(10, 20, 70, 60)

    'Ellipse
    hRegions(rELLIPTIC) = CreateEllipticRgn(100, 20, 180, 60)

    'Round-Rect
    hRegions(rROUNDRECT) = CreateRoundRectRgn(300, 20, 400, 60, 20, 20)
End Sub




'
' Be sure to delete objects
'
Private Sub Form_Unload(Cancel As Integer)
    Dim i%
    For i% = 0 To 4
        dl = DeleteObject(hRegions(i%))
    Next i%
    ' Delete combined region if it exists
    If hCombined <> 0 Then dl = DeleteObject(hCombined)
End Sub

Private Sub picOut_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim myX As Long, myY As Long, i%, inAny%
    myX = CLng(X)
    myY = CLng(Y)
    
    For i% = 0 To 4
        If PtInRegion(hRegions(i%), myX, myY) Then
            rSelected%(i%) = Not rSelected%(i%)
            inAny% = True
            Exit For
        End If
    Next i%
    
    ' Right button on non-region area deselects all
    If (Not inAny%) And (Button And vbRightButton) Then
        For i% = 0 To 4
            rSelected%(i%) = 0
        Next i%
    End If
    
    picOut.Refresh
End Sub

Private Sub picOut_Paint()
#If Win32 Then
    Dim hBrush As Long
#Else
    Dim hBrush As Integer
#End If
    
    hBrush = CreateSolidBrush(QBColor(0))
    
    picOut.FillColor = QBColor(14) 'Yellow
    dl = PaintRgn(picOut.hDC, hRegions(rRECT))
    If rSelected%(rRECT) Then dl = FrameRgn(picOut.hDC, hRegions(rRECT), hBrush, 2, 2)
    
    picOut.FillColor = QBColor(12) 'Red
    dl = PaintRgn(picOut.hDC, hRegions(rELLIPTIC))
    If rSelected%(rELLIPTIC) Then dl = FrameRgn(picOut.hDC, hRegions(rELLIPTIC), hBrush, 2, 2)
    
    picOut.FillColor = QBColor(10) 'Green
    dl = PaintRgn(picOut.hDC, hRegions(rPOLYGON))
    If rSelected%(rPOLYGON) Then dl = FrameRgn(picOut.hDC, hRegions(rPOLYGON), hBrush, 2, 2)
    
    picOut.FillColor = QBColor(11) 'Cyan
    dl = PaintRgn(picOut.hDC, hRegions(rROUNDRECT))
    If rSelected%(rROUNDRECT) Then dl = FrameRgn(picOut.hDC, hRegions(rROUNDRECT), hBrush, 2, 2)
    
    picOut.FillColor = QBColor(9) 'Blue
    dl = PaintRgn(picOut.hDC, hRegions(rPOLYPOLYGON))
    Screen.MousePointer = vbHourglass
    picOut.Enabled = False
    If rSelected%(rPOLYPOLYGON) Then dl = FrameRgn(picOut.hDC, hRegions(rPOLYPOLYGON), hBrush, 2, 2)
    picOut.Enabled = True
    Screen.MousePointer = vbDefault
    
    dl = DeleteObject(hBrush)
End Sub


