Attribute VB_Name = "ENMFNTX1"
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved.

' Logical Font
Public Const LF_FACESIZE = 32
Public Const LF_FULLFACESIZE = 64

Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE - 1) As Byte
End Type


' This used to be a NEWLOGFONT in Win16
Type ENUMLOGFONT
        elfLogFont As LOGFONT
        elfFullName(LF_FULLFACESIZE - 1) As Byte
        elfStyle(LF_FACESIZE - 1) As Byte
End Type

' Structure passed to FONTENUMPROC
' NOTE: NEWTEXTMETRIC is the same as TEXTMETRIC plus 4 new fields
Type NEWTEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
        ntmFlags As Long
        ntmSizeEM As Long
        ntmCellHeight As Long
        ntmAveWidth As Long
End Type


Public nlf As ENUMLOGFONT

Public ntm As NEWTEXTMETRIC

Public Const TMPF_TRUETYPE = 4

'  EnumFonts Masks
Public Const RASTER_FONTTYPE = &H1
Public Const DEVICE_FONTTYPE = &H2
Public Const TRUETYPE_FONTTYPE = &H4

Declare Function EnumFontFamilies Lib "gdi32" Alias "EnumFontFamiliesA" (ByVal hdc As Long, ByVal lpszFamily As String, ByVal lpEnumFontFamProc As Long, ByVal lParam As Long) As Long
Declare Function EnumFontFamiliesEx Lib "gdi32" Alias "EnumFontFamiliesExA" (ByVal hdc As Long, lpLogFont As LOGFONT, ByVal lpEnumFontProc As Long, ByVal lParam As Long, ByVal dw As Long) As Long
Declare Function EnumFonts Lib "gdi32" Alias "EnumFontsA" (ByVal hdc As Long, ByVal lpsz As String, ByVal lpFontEnumProc As Long, ByVal lParam As Long) As Long

Public Function Callback1_EnumFonts(ByVal lpLogFont As Long, ByVal lpTextMetrics As Long, ByVal nFontType As Long, ByVal lpData As Long) As Long
    Dim fullname$, stylename$, facename$
    
    ' agCopyData copies the data referenced by the pointer
    ' provided into a structure
    agCopyData ByVal lpLogFont, nlf, Len(nlf)
    agCopyData ByVal lpTextMetrics, ntm, Len(ntm)
    
    ' Only look at TrueType fonts.
    If (lpData = 1) And ((nFontType And TRUETYPE_FONTTYPE) = 0) Then
      Callback1_EnumFonts = True
      Exit Function
      End If
    
    If (nFontType And TRUETYPE_FONTTYPE) <> 0 Then
        fullname$ = GetNameFromByteArray(nlf.elfFullName)
        stylename$ = GetNameFromByteArray(nlf.elfStyle)
    End If
    If lpData = 2 And (nFontType And RASTER_FONTTYPE) <> 0 Then
        fullname$ = " Height,Width: " & ntm.tmHeight & "," & ntm.tmAveCharWidth
    End If
    
    ' Non truetype fonts do not have a valid lfFullname and lfStyle field
    facename$ = GetNameFromByteArray(nlf.elfLogFont.lfFaceName)
    
    If lpData = 2 Then
        enmfntx.List1.AddItem facename$ & " -- " & fullname$ & " " & stylename$
    Else
        enmfntx.List2.AddItem facename$ & " -- " & fullname$ & " " & stylename$
    End If
    Callback1_EnumFonts = True
End Function

'
' Retrieves a string from a byte array which contains
' a null terminated ANSI string
'
Public Function GetNameFromByteArray$(src() As Byte)
    Dim t$, zeropos%
    ' The array is ANSI, and needs to be converted into Unicode
    ' to fit VB's internal format
    t$ = StrConv(CStr(src), vbUnicode)
    ' And remove the null terminating character and any trailing characters
    zeropos% = InStr(t$, Chr$(0))
    If zeropos% > 1 Then t$ = Left$(t$, zeropos% - 1)
    GetNameFromByteArray$ = t$
End Function

