VERSION 5.00
Begin VB.Form frmAsync 
   Caption         =   "Asynchronous File I/O Test"
   ClientHeight    =   3015
   ClientLeft      =   1350
   ClientTop       =   1890
   ClientWidth     =   4635
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3015
   ScaleWidth      =   4635
   Begin VB.CommandButton cmdAsync 
      Caption         =   "Asynchronous"
      Height          =   495
      Left            =   2400
      TabIndex        =   2
      Top             =   540
      Width           =   1335
   End
   Begin VB.CommandButton cmdSync 
      Caption         =   "Synchrounous"
      Height          =   495
      Left            =   420
      TabIndex        =   0
      Top             =   540
      Width           =   1395
   End
   Begin VB.Label lblAsync 
      Caption         =   "0"
      Height          =   255
      Left            =   2460
      TabIndex        =   3
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label lblSync 
      Caption         =   "0"
      Height          =   255
      Left            =   420
      TabIndex        =   1
      Top             =   1320
      Width           =   1335
   End
End
Attribute VB_Name = "frmAsync"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Important note - overlapping file I/O as shown
' here is not particularly useful.  However, see
' the chapter 14 examples for use of overlapped I/O
' with pipes.
' Also note that this example will not be illustrative
' under Windows 95 which does not support overlapped
' writes to a disk

Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (ByVal lpEventAttributes As Long, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFileAsync Lib "kernel32" Alias "WriteFile" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As OVERLAPPED) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function ResetEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Private Declare Function WaitForMultipleObjects Lib "kernel32" (ByVal nCount As Long, lpHandles As Long, ByVal bWaitAll As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long

Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const CREATE_ALWAYS = 2
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const FILE_FLAG_WRITE_THROUGH = &H80000000
Private Const FILE_FLAG_OVERLAPPED = &H40000000
Private Const FILE_FLAG_NO_BUFFERING = &H20000000
Private Const FILE_FLAG_RANDOM_ACCESS = &H10000000
Private Const FILE_FLAG_SEQUENTIAL_SCAN = &H8000000
Private Const FILE_FLAG_DELETE_ON_CLOSE = &H4000000
Private Const FILE_FLAG_BACKUP_SEMANTICS = &H2000000
Private Const FILE_FLAG_POSIX_SEMANTICS = &H1000000
Private Const FILE_BEGIN = 0
Private Const FILE_CURRENT = 1
Private Const FILE_END = 2
Private Const INFINITE = &HFFFF      '  Infinite timeout
Private Const INVALID_HANDLE_VALUE = -1

Private Const Writes& = 100

Private Type OVERLAPPED
        Internal As Long
        InternalHigh As Long
        offset As Long
        OffsetHigh As Long
        hEvent As Long
End Type

Dim fhnd&
Dim fhndasync&
Dim eventlist(Writes&) As Long
Dim overlaps(Writes&) As OVERLAPPED
Dim FileContents$



Private Sub cmdAsync_Click()
    Dim cnt&, res&
    Dim written&
    lblSync = "0"
    If fhnd = INVALID_HANDLE_VALUE Then
        MsgBox "No valid file pointer"
        Exit Sub
    End If
    For cnt& = 1 To Writes
        With overlaps(cnt)
            .offset = 0
            .OffsetHigh = 0
            ' Make sure event is reset
            Call ResetEvent(eventlist(cnt))
            .hEvent = eventlist(cnt)
        End With
        res = WriteFileAsync(fhndasync, ByVal FileContents$, Len(FileContents$), written, overlaps(cnt))
        lblAsync = Str$(cnt)
        lblAsync.Refresh
    Next cnt
    lblAsync = "Waiting"
    lblAsync.Refresh
    Call WaitForMultipleObjects(Writes, eventlist(1), True, INFINITE)
    lblAsync = "Done"

End Sub

' Performs synchronous writes to a file
Private Sub cmdSync_Click()
    Dim cnt&, res&
    Dim written&
    lblSync = "0"
    If fhnd = INVALID_HANDLE_VALUE Then
        MsgBox "No valid file pointer"
        Exit Sub
    End If
    For cnt& = 1 To Writes
        Call SetFilePointer(fhnd, 0, 0, FILE_BEGIN)
        res = WriteFile(fhnd, ByVal FileContents$, Len(FileContents$), written, 0)
        lblSync = Str$(cnt)
        lblSync.Refresh
    Next cnt

End Sub

Private Sub Form_Load()
    Dim x&
    fhnd = CreateFile("sync.tmp", GENERIC_READ Or GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_RANDOM_ACCESS, 0)
    fhndasync = CreateFile("async.tmp", GENERIC_READ Or GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_RANDOM_ACCESS Or FILE_FLAG_OVERLAPPED, 0)
    FileContents$ = String$(200000, "A")
    
    ' Initialize event objects
    For x = 1 To Writes
        eventlist(x) = CreateEvent(0, True, False, vbNullString)
    Next x
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim x
    If fhnd <> INVALID_HANDLE_VALUE Then Call CloseHandle(fhnd)
    If fhndasync <> INVALID_HANDLE_VALUE Then Call CloseHandle(fhndasync)
    ' Be sure to clean up events
    For x = 1 To Writes
        If eventlist(x) <> 0 Then DeleteObject (eventlist(x))
    Next x
End Sub
