Attribute VB_Name = "MDIPaintMod"
Option Explicit

Public OldWindowProc As Long  ' Original window proc

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GW_CHILD = 5
Public Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function SelectClipRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long
Private Declare Function ExcludeClipRect Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function ValidateRectBynum Lib "user32" Alias "ValidateRect" (ByVal hWnd As Long, ByVal lpRect As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Const COLOR_BACKGROUND = 1
Public Const WM_ERASEBKGND = &H14

Private Const SRCCOPY = &HCC0020 ' (DWORD) dest = source

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

' Bitmap Header Definition
Private Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Public Function SubClass1_WndMessage(ByVal hWnd As OLE_HANDLE, ByVal Msg As OLE_HANDLE, ByVal wp As OLE_HANDLE, ByVal lp As Long) As Long
    Dim tdc&
    Dim usedc&
    Dim oldbm&
    Dim bm As BITMAP
    Dim rc As RECT
    Dim offsx&, offsy&
    
    If Msg <> WM_ERASEBKGND Then
       ' Call the default window procedure
       SubClass1_WndMessage = CallWindowProc(OldWindowProc, hWnd, Msg, wp, lp)
       Exit Function
    End If
    
    ' Get a DC to draw into
    usedc = GetDC(hWnd)
    ' Create a compatible DC to use
    tdc = CreateCompatibleDC(usedc)
    
    ' Gets the bitmap handle of the background bitmap
    oldbm = SelectObject(tdc, MDIForm1.Picture1.Picture)
    Call GetObjectAPI(MDIForm1.Picture1.Picture, Len(bm), bm)
    Call GetClientRect(hWnd, rc)
    ' Decide where to place the MDI client logo
    offsx = 20
    offsy = 20
    
    ' Set the clipping region to the entire window -
    ' necessary because the hDC provided has a clipping
    ' region set.
    Call SelectClipRgn(usedc, 0)
    
    ' We exclude the bitmap area - this reduces flicker (try removing it)
    Call ExcludeClipRect(usedc, offsx, offsy, offsx + bm.bmWidth, offsy + bm.bmHeight)
    Call FillRect(usedc, rc, COLOR_BACKGROUND)
    
    ' And restore the clip region before painting the bitmap
    Call SelectClipRgn(usedc, 0)
    
    Call BitBlt(usedc, offsx, offsy, bm.bmWidth, bm.bmHeight, tdc, 0, 0, SRCCOPY)
    Call ReleaseDC(hWnd, usedc)
    Call SelectObject(tdc, oldbm)
    Call DeleteDC(tdc)
    ' This was added for VB5
    Call ValidateRectBynum(hWnd, 0)
    SubClass1_WndMessage = True
End Function

