VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "dwNetwork"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Class dwNetwork
' Copyright (c) 1996 by Desaware Inc.  All Rights Reserved
' Part of the Desaware API Class Library
' For further information contact:
' Desaware Inc.
' 1100 E. Hamilton Ave.  Suite #4
' Campbell, CA 95008
' (408) 377-4770
' www.desaware.com


Option Explicit

Private Declare Function intWNetAddConnection Lib "mpr.dll" Alias "WNetAddConnectionA" (ByVal lpszNetPath As String, ByVal lpszPassword As String, ByVal lpszLocalName As String) As Long
Private Declare Function intWNetCancelConnection Lib "mpr.dll" Alias "WNetCancelConnectionA" (ByVal lpszName As String, ByVal bForce As Long) As Long
Private Declare Function intWNetCancelConnection2 Lib "mpr.dll" Alias "WNetCancelConnection2A" (ByVal lpname As String, ByVal dwFlags As Long, ByVal fForce As Long) As Long
Private Declare Function intWNetConnectionDialog Lib "mpr.dll" Alias "WNetConnectionDialog" (ByVal hwnd As Long, ByVal dwType As Long) As Long
Private Declare Function intWNetDisconnectDialog Lib "mpr.dll" Alias "WNetDisconnectDialog" (ByVal hwnd As Long, ByVal dwType As Long) As Long
Private Declare Function intWNetGetConnection Lib "mpr.dll" Alias "WNetGetConnectionA" (ByVal lpszLocalName As String, ByVal lpszRemoteName As String, cbRemoteName As Long) As Long
Private Declare Function intWNetGetUser Lib "mpr.dll" Alias "WNetGetUserA" (ByVal lpname As String, ByVal lpUserName As String, lpnLength As Long) As Long

Private Const ERROR_MORE_DATA = 234 '  dderror
Private Const ERROR_EXTENDED_ERROR = 1208&

' Always loaded with last network API error
Public LastError As Long
' Set only if LastError is ERROR_EXTENDED_ERROR (See dwNetwork)
Public LastNetError As dwNetError


Public Function WNetAddConnection(RemoteName As String, Password As String, LocalName As String) As Long
   Dim res&
   res = intWNetAddConnection(RemoteName, Password, LocalName)
   If res <> 0 Then SetErrorValues
   WNetAddConnection = res
End Function

' Loads the LastError and LastNetError information when an error occurs
Public Sub SetErrorValues()
      LastError = Err.LastDllError
      If LastError = ERROR_EXTENDED_ERROR Then
         ' This error object initializes itself
         Set LastNetError = New dwNetError
      End If
End Sub


Public Function WNetCancelConnection(lpszName As String, fForce As Long) As Long
   Dim res&
   res = intWNetCancelConnection(lpszName, fForce)
   If res <> 0 Then SetErrorValues
   WNetCancelConnection = res
End Function

Public Function WNetCancelConnection2(lpszName As String, dwConnection As Long, fForce As Long) As Long
   Dim res&
   res = intWNetCancelConnection2(lpszName, dwConnection, fForce)
   If res <> 0 Then SetErrorValues
   WNetCancelConnection2 = res
End Function


Public Function WNetConnectionDialog(hwnd As Long, dwResourceType As Long) As Long
   Dim res&
   res = intWNetConnectionDialog(hwnd, dwResourceType)
   If res <> 0 Then SetErrorValues
   WNetConnectionDialog = res
End Function

Public Function WNetDisconnectDialog(hwnd As Long, dwResourceType As Long) As Long
   Dim res&
   res = intWNetDisconnectDialog(hwnd, dwResourceType)
   If res <> 0 Then SetErrorValues
   WNetDisconnectDialog = res
End Function


Public Function WNetGetConnection(szLocalName As String) As String
   Dim buflen&
   Dim res&
   Dim buf As String
   buf = String$(261, 0)
   buflen = 260   ' Maximum path
   res = intWNetGetConnection(szLocalName, buf, buflen)
   If res <> 0 Then
      SetErrorValues
   Else
      ' Retrieve the string without the null terminator
      WNetGetConnection = agGetStringFromLPSTR(buf)
   End If
End Function


Public Function WNetGetUniversalName(lpLocalPath As String, dwInfoLevel As Long) As dwRemoteNameInfo
   Dim res&
   Dim newobject As New dwRemoteNameInfo
   res = newobject.Load(lpLocalPath, dwInfoLevel)
   If res <> 0 Then
      SetErrorValues
   Else
      Set WNetGetUniversalName = newobject
   End If
End Function

Public Function WNetGetUser(lpLocalName$) As String
   Dim res&
   Dim tbuf As String
   Dim BufferSize&
   tbuf = String$(256, 0)
   BufferSize = Len(tbuf)
   res = intWNetGetUser(lpLocalName, tbuf, BufferSize)
   If res <> 0 Then
      SetErrorValues
   Else
      WNetGetUser = agGetStringFromLPSTR(tbuf)
   End If
End Function


